glibmm 2.56.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::DBus::MenuModel Class Reference

MenuModel - A D-Bus Gio::MenuModel implementation. More...

`#include <giomm/dbusmenumodel.h>`

Inheritance diagram for Gio::DBus::MenuModel:
[legend]

## Public Member Functions
| MenuModel (MenuModel&& src) noexcept
MenuModel& | operator= (MenuModel&& src) noexcept
| ~MenuModel () noexcept override
GDBusMenuModel* | gobj ()
| Provides access to the underlying C GObject. More...
const GDBusMenuModel* | gobj () const
| Provides access to the underlying C GObject. More...
GDBusMenuModel* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Public Member Functions inherited from Gio::MenuModel
| MenuModel (MenuModel&& src) noexcept
MenuModel& | operator= (MenuModel&& src) noexcept
| ~MenuModel () noexcept override
GMenuModel* | gobj ()
| Provides access to the underlying C GObject. More...
const GMenuModel* | gobj () const
| Provides access to the underlying C GObject. More...
GMenuModel* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::VariantBase | get_item_attribute (int item_index, MenuAttribute attribute, const Glib::VariantType& expected_type)
| Queries the item at position item_index in model for the attribute specified by attribute. More...
const Glib::VariantBase | get_item_attribute (int item_index, MenuAttribute attribute, const Glib::VariantType& expected_type) const
| Queries the item at position item_index in model for the attribute specified by attribute. More...
Glib::RefPtr< MenuModel > | get_item_link (int item_index, MenuLink link)
| Queries the item at position item_index in model for the link specified by link. More...
Glib::RefPtr< const MenuModel > | get_item_link (int item_index, MenuLink link) const
| Queries the item at position item_index in model for the link specified by link. More...
bool | is_mutable () const
| Queries if model is mutable. More...
int | get_n_items () const
| Query the number of items in model. More...
Glib::RefPtr< MenuAttributeIter > | iterate_item_attributes (int item_index)
| Creates a MenuAttributeIter to iterate over the attributes of the item at position item_index in model. More...
Glib::RefPtr< const MenuAttributeIter > | iterate_item_attributes (int item_index) const
| Creates a MenuAttributeIter to iterate over the attributes of the item at position item_index in model. More...
Glib::RefPtr< MenuLinkIter > | iterate_item_links (int item_index)
| Creates a MenuLinkIter to iterate over the links of the item at position item_index in model. More...
Glib::RefPtr< const MenuLinkIter > | iterate_item_links (int item_index) const
| Creates a MenuLinkIter to iterate over the links of the item at position item_index in model. More...
void | items_changed (int position, int removed, int added)
| Requests emission of the MenuModel::signal_items_changed() signal on model. More...
Glib::SignalProxy< void, int, int, int > | signal_items_changed ()
Public Member Functions inherited from Glib::Object
| Object (const Object&)=delete
Object& | operator= (const Object&)=delete
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase&)=delete
ObjectBase& | operator= (const ObjectBase&)=delete
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | connect_property_changed (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< MenuModel > | get (const Glib::RefPtr< Connection >& connection, const Glib::ustring& bus_name, const Glib::ustring& object_path)
| Obtains a DBusMenuModel for the menu model which is exported at the given bus_name and object_path. More...
Static Public Member Functions inherited from Gio::MenuModel
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| MenuModel ()
Protected Member Functions inherited from Gio::MenuModel
| MenuModel ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase&& src) noexcept
ObjectBase& | operator= (ObjectBase&& src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject* castitem)
void | initialize_move (GObject* castitem, Glib::ObjectBase* previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::DBus::MenuModel > | wrap (GDBusMenuModel* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gio::MenuModel
Glib::RefPtr< Gio::MenuModel > | wrap (GMenuModel* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

MenuModel - A D-Bus Gio::MenuModel implementation.

MenuModel is an implementation of Gio::MenuModel that can be used as a proxy for a menu model that is exported over D-Bus with Gio::DBus::Connection::export_menu_model().

Since glibmm 2.32:

## Constructor & Destructor Documentation

## ◆ MenuModel() [1/2]

Gio::DBus::MenuModel::MenuModel | ( | MenuModel&& | src | ) |
| noexcept

## ◆ ~MenuModel()

Gio::DBus::MenuModel::~MenuModel | ( |  | ) |
| override noexcept

## ◆ MenuModel() [2/2]

Gio::DBus::MenuModel::MenuModel | ( |  | ) |
| protected

## Member Function Documentation

## ◆ get()

static Glib::RefPtr<MenuModel> Gio::DBus::MenuModel::get | ( | const Glib::RefPtr< Connection >& | connection,
|  | const Glib::ustring& | bus_name,
|  | const Glib::ustring& | object_path
| ) |  |
| static

Obtains a DBusMenuModel for the menu model which is exported at the given bus_name and object_path.

The thread default main context is taken at the time of this call. All signals on the menu model (and any linked models) are reported with respect to this context. All calls on the returned menu model (and linked models) must also originate from this same context, with the thread default main context unchanged.

Since glibmm 2.32:

Parameters

  connection | A DBusConnection.
  bus_name | The bus name which exports the menu model or `nullptr` if connection is not a message bus connection.
  object_path | The object path at which the menu model is exported.

Returns
  A DBusMenuModel object. Free with Glib::object_unref().

## ◆ get_type()

static GType Gio::DBus::MenuModel::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GDBusMenuModel* Gio::DBus::MenuModel::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GDBusMenuModel* Gio::DBus::MenuModel::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GDBusMenuModel* Gio::DBus::MenuModel::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

MenuModel& Gio::DBus::MenuModel::operator= | ( | MenuModel&& | src | ) |
| noexcept

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gio::DBus::MenuModel > wrap | ( | GDBusMenuModel * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.